/**
 * @activewidgets/options 3.5.0
 * Copyright (C) 2023 ActiveWidgets SARL. All Rights Reserved.
 * This code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this package.
 */

function K({ callbacks: e }, r) {
  e.cell.push(r);
}
function ve(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => K(r, e);
}
function z({ callbacks: e }, r) {
  typeof r == "function" ? e.column.push(r) : e.beforeColumn.unshift(() => r);
}
function $e(e) {
  return (r) => z(r, e);
}
function H({ callbacks: e }, r) {
  e.data || (e.data = []), e.data.push(r);
}
function Ee(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => H(r, e);
}
function J({ state: e, callbacks: r }, f, u, i) {
  let { config: s } = e;
  function t(o) {
    let a = o.format;
    if (a) {
      if (typeof a == "string" && a in s.formats && (a = s.formats[a]), typeof a == "function")
        return { fn: { text: a } };
      for (let g = 0; g < r.formats.length; g++) {
        let d = r.formats[g](a);
        if (d)
          return { fn: { text: d } };
      }
      throw new Error("unknown format pattern - " + a);
    }
  }
  s.formats || (s.formats = {}, r.formats = [], r.afterColumn.push(t)), i ? r.formats.push(i) : s.formats[f] = u;
}
function W(e, r) {
  let f;
  if (typeof e == "function" && !r)
    f = e, e = null, r = null;
  else if (typeof e != "string" || !r)
    throw new Error("invalid arguments");
  return (u) => J(u, e, r, f);
}
const { assign: D } = Object;
function Y({ props: e, state: r, api: f, callbacks: u }, i, s) {
  let { config: t } = r;
  if (i && (t.baseURL = i), s && (t.fetch = s), t.http)
    return;
  t.http = !0;
  function o(a, g) {
    let { identity: d } = e, c;
    function w(y, $) {
      let C = new URL(y, t.baseURL || location.href), E = D({}, t.fetch && t.fetch.headers, $ && $.headers), b = D({}, t.fetch, $, { headers: E });
      return E.Accept || (E.Accept = "application/json; text/plain; */*"), b.body && !E["Content-Type"] && (E["Content-Type"] = "application/json"), Promise.resolve().then(() => u.request(C, b)).then((n) => (c = n, u.response(n)));
    }
    function l(y) {
      let $ = D(...u.params.map((E) => E(y))), C = {};
      return Object.keys($).forEach((E) => {
        typeof $[E] < "u" && (C[E] = $[E]);
      }), C;
    }
    function m(y) {
      if (u.data) {
        let $, C, E = u.data.length;
        for ($ = 0; $ < E; $++)
          if (C = u.data[$](y, c), typeof C < "u")
            return C;
      }
      return y;
    }
    return g ? g(a, w, d, l, m) : u.params ? (y) => w(`${a}?${new URLSearchParams(l(y))}`).then(m) : () => w(a).then(m);
  }
  u.inputs.unshift((a, g) => {
    if (typeof a != "string")
      return;
    if (g !== f.rows || !u.httpops)
      return o(a);
    let d = u.httpops.map((c) => o(a, c));
    return D({ getRows: o(a) }, ...d);
  });
}
function G(e, r) {
  return typeof r > "u" && typeof e == "object" && (r = e, e = void 0), e && typeof URL < "u" && typeof location < "u" && (e = new URL(e, location.href), e.pathname += /\/$/.test(e.pathname) ? "" : "/"), (f) => Y(f, e, r);
}
let N = Intl.NumberFormat, P = Intl.DateTimeFormat, Q = {
  style: N,
  currency: N,
  useGrouping: N,
  minimumIntegerDigits: N,
  minimumFractionDigits: N,
  maximumFractionDigits: N,
  minimumSignificantDigits: N,
  maximumSignificantDigits: N,
  year: P,
  month: P,
  day: P,
  weekday: P,
  hour: P,
  minute: P,
  second: P
};
function Ce(e) {
  return W((r) => {
    if (typeof r != "object")
      return;
    let f = Object.keys(r).reduce((s, t) => s || Q[t], null);
    if (!f)
      return;
    let u = new f(e, r), i = (s) => s;
    return f === Intl.DateTimeFormat && (i = (s) => typeof s == "number" ? s : Date.parse(s)), function(s) {
      try {
        return u.format(i(s));
      } catch {
        return s;
      }
    };
  });
}
function V({ callbacks: e }, r) {
  e.httpops || (e.httpops = []), e.httpops.push(r);
}
function X(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => V(r, e);
}
function Z({ callbacks: e }, r) {
  e.params || (e.params = []), e.params.push(r);
}
function be(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => Z(r, e);
}
function _({ callbacks: e }, r) {
  e.request = r;
}
function Ae(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => _(r, e);
}
function ee({ callbacks: e }, r) {
  e.response = r;
}
function je(e) {
  if (typeof e != "function")
    throw new Error("function expected");
  return (r) => ee(r, e);
}
function I(e) {
  return Array.isArray(e) ? e.map(encodeURIComponent).join("/") : encodeURIComponent(e);
}
function te(e, r) {
  function f(s) {
    return r(e, { method: "POST", body: JSON.stringify(s) });
  }
  function u(s, t) {
    return r(`${e}/${I(s)}`, { method: "PATCH", body: JSON.stringify(t) });
  }
  function i(s) {
    return r(`${e}/${I(s)}`, { method: "DELETE" });
  }
  return { insertRow: f, updateRow: u, deleteRow: i };
}
function Ne(e, r) {
  return [
    G(e, r),
    X(te)
  ];
}
function re({ callbacks: e }, r) {
  typeof r == "function" ? e.row.push(r) : e.row.push(() => r);
}
function Pe(e) {
  return (r) => re(r, e);
}
function ne({ state: e, update: r, cls: f, api: u, callbacks: i }) {
  let s = 0;
  i.click.push(function({ target: t }) {
    let o = u.cellFromElement(t);
    o && o.section === "main" && (s = o.row.index, e.$rows = {}, r());
  }), i.row.push(function(t, o, a) {
    if (a === s)
      return { [f]: "ax-selected" };
  });
}
function De() {
  return ne;
}
function oe({ callbacks: e }, r, f) {
  e.beforeColumn.push((u) => {
    if (u.type === r)
      return f;
  });
}
function Oe(e, r) {
  return (f) => oe(f, e, r);
}
function ie({ state: e, update: r, cls: f, api: u, callbacks: i }) {
  let s, t, o, a;
  function g(c, w) {
    c && w && (a = c, o = w, t = c.id, s = w.id, e.$rows = {}, r(), d(c));
  }
  function d(c) {
    let { scrollY: w, scrollHeight: l, clientHeight: m } = e, y = c.pos * l * (1 - 1 / u.rows.length) / (l - m);
    c.pos < w && y < w && u.scrollTo({ y }), y = 1 - (1 - c.pos) * l * (1 - 1 / u.rows.length) / (l - m), c.pos > w && y > w && u.scrollTo({ y });
  }
  i.keydown.push(({ keyCode: c }) => {
    a && (c === 37 && g(a, u.columns.get(o.index - 1)), c === 38 && g(u.rows.get(a.index - 1), o), c === 39 && g(a, u.columns.get(o.index + 1)), c === 40 && g(u.rows.get(a.index + 1), o));
  }), i.click.push(({ target: c }) => {
    let w = u.cellFromElement(c);
    w && w.section === "main" && g(w.row, w.column);
  }), i.row.push((c, w) => {
    if (w === t)
      return { active: s };
  }), i.cell.push((c, w, l, m) => {
    if (m.id === t && l.id === s)
      return { active: !0, [f]: "ax-active-cell" };
  });
}
function ke() {
  return ie;
}
function ue({ state: e, update: r, cls: f, api: u, callbacks: i }) {
  let s;
  i.keydown.push(({ keyCode: t }) => {
    s && (t === 38 && (s = u.rows.get(s.index - 1), e.$rows = {}, r()), t === 40 && (s = u.rows.get(s.index + 1), e.$rows = {}, r()));
  }), i.click.push(({ target: t }) => {
    let o = u.cellFromElement(t);
    o && o.section === "main" && (s = u.rows.get(o.row.index), e.$rows = {}, r());
  }), i.row.push((t, o) => {
    if (s && o === s.id)
      return { active: !0, [f]: "ax-active-row" };
  });
}
function Te() {
  return ue;
}
function se({ callbacks: e }, r) {
  let f = () => r, u;
  typeof r == "function" && (f = r);
  function i(s, t) {
    return Promise.resolve(f(s, t)).then((o) => (t = t || {}, t.headers = Object.assign({}, t.headers, o), u(s, t)));
  }
  e.init.push(() => {
    u = e.request, e.request = i;
  });
}
function Ie(e) {
  return (r) => se(r, e);
}
function fe({ props: e, state: r, update: f, api: u, callbacks: i }) {
  let { operations: s } = u, t, o, a, g;
  function d(m) {
    let { identity: y } = e;
    if (!y) {
      console.warn("cannot edit - identity prop not set");
      return;
    }
    if (!s.updateRow) {
      console.warn("cannot edit - updateRow operation missing");
      return;
    }
    if (!(m.column.editable === !1 || m.row.editable === !1))
      return !0;
  }
  function c(m) {
    o = m.row.id, t = m.column.id, a = !1, r.$rows = {}, f();
  }
  function w() {
    o = void 0, t = void 0, r.$rows = {}, f(), u.el && u.el.focus();
  }
  function l(m, y) {
    function $(b) {
      g = b.target.value, a = !0;
    }
    function C() {
      if (a) {
        let b = { [m.field]: g };
        u.rows.update(y, b), s.updateRow(y.id, b).then((n) => console.log(n));
      }
      w();
    }
    function E(b) {
      if (b.keyCode === 13)
        return C();
      if (b.keyCode === 27)
        return w();
    }
    return { onInput: $, onCommit: C, onCancel: w, onBlur: C, onKeyDown: E };
  }
  i.keydown.push(({ target: m, keyCode: y }) => {
    let { activeCell: $ } = e;
    $ && y === 13 && m.nodeName !== "INPUT" && d($) && c($);
  }), i.dblclick.push(({ target: m }) => {
    let y = u.cellFromElement(m);
    y && y.section === "main" && d(y) && c(y);
  }), i.row.push((m, y) => {
    if (y === o)
      return { edit: t };
  }), i.cell.push((m, y, $, C) => {
    if (C.id === o && $.id === t)
      return { template: "edit", actions: l($, C) };
  });
}
function Re() {
  return fe;
}
function ae(e, r) {
  function f(i) {
    let s, t, o, a;
    switch (i.type) {
      case "literal":
        return i.value;
      case "identifier":
        return r[i.name];
      case "member":
        return s = f(i.object), s && s[i.property];
      case "binary":
        switch (t = f(i.left), o = f(i.right), i.operator) {
          case "=":
            return t == o;
          case ">":
            return t > o;
          case "<":
            return t < o;
          case ">=":
            return t >= o;
          case "<=":
            return t <= o;
          case "!=":
            return t != o;
          case "<>":
            return t != o;
          case "LIKE":
            return B(t, o);
          case "ILIKE":
            return ce(t, o);
          default:
            throw u(i);
        }
      case "unary":
        switch (a = f(i.argument), i.operator) {
          case "NOT":
            return !a;
          default:
            throw u(i);
        }
      case "logical":
        switch (i.operator) {
          case "AND":
            return i.arguments.every(f);
          case "OR":
            return i.arguments.some(f);
          default:
            throw u(i);
        }
      default:
        throw Error(`Unknown expression type: ${i.type}`);
    }
  }
  function u(i) {
    return Error(`Unknown ${i.type} operator: ${i.operator}`);
  }
  return f(e);
}
function B(e, r) {
  let f = String(e), u = r.split("%"), i = u.length, s = u[0], t = u[i - 1], o = i == 3 ? u[1] : "";
  return i == 1 ? f === r : !(s && !f.startsWith(s) || t && !f.endsWith(t) || o && f.indexOf(o) < 0 || i > 3);
}
function ce(e, r) {
  return B(String(e).toLowerCase(), r.toLowerCase());
}
let R = {
  equality: "= <> !=",
  comparison: "< > <= >=",
  text: "LIKE ILIKE"
}, U = {};
Object.keys(R).forEach((e) => R[e].split(" ").forEach((r) => {
  U[r] = e;
}));
function F(e) {
  return e.replace(/([=<>!]+)/g, " $1 ").replace(/\s+/g, " ").replace(/^ | $/g, "").split(" ");
}
function q(e) {
  if (!e)
    return;
  let r = "", f = e.replace(/''/g, r).split("'").map((d) => d.replace(RegExp(r, "g"), "'")), u = f.map((d, c) => c % 2 ? r + c : d).join("").replace(/\s+/g, " ");
  function i(d) {
    if (d.slice(0, 1) == r)
      return f[d.slice(1)];
    if (!isNaN(d))
      return Number(d);
    throw Error("Unknown literal: " + d);
  }
  function s(d) {
    return {
      type: "literal",
      value: i(d)
    };
  }
  function t(d) {
    let [c, ...w] = d.split("."), l = { type: "identifier", name: c };
    return w.forEach((m) => {
      l = { type: "member", object: l, property: m };
    }), l;
  }
  function o(d, c, w, ...l) {
    if (d.toUpperCase() == "NOT")
      return {
        type: "unary",
        variant: "logical",
        operator: "NOT",
        argument: o(c, w, ...l)
      };
    if (l.length)
      throw Error("Unexpected tokens: " + l.join(" "));
    let m = U[c.toUpperCase()];
    if (!m)
      throw Error("Unknown operator: " + c);
    return {
      type: "binary",
      variant: m,
      operator: c.toUpperCase(),
      left: t(d),
      right: s(w)
    };
  }
  function a(d) {
    let c = d.split(/ AND /i);
    return c.length > 1 ? {
      type: "logical",
      variant: "logical",
      operator: "AND",
      arguments: c.map((w) => o(...F(w)))
    } : o(...F(d));
  }
  function g(d) {
    let c = d.split(/ OR /i);
    return c.length > 1 ? {
      type: "logical",
      variant: "logical",
      operator: "OR",
      arguments: c.map(a)
    } : a(d);
  }
  return g(u);
}
const { assign: M } = Object;
function le({ state: e, update: r, on: f, fail: u, api: i, callbacks: s }) {
  let t = !1, o = [], a;
  if (s.transform)
    return;
  s.transform = [], s.getparams = [];
  function g(l) {
    return s.transform.forEach((m) => {
      l = m(l);
    }), l;
  }
  function d() {
    let l = i.operations.getRows, m = {};
    return t = !!l.length, t && (m = M({}, ...s.getparams.map((y) => y()))), a && t ? a(m) : Promise.resolve(m).then(l).then((y) => {
      if (!y)
        o = [];
      else if (Array.isArray(y))
        o = y;
      else if (Array.isArray(y.items))
        o = y.items;
      else
        throw new Error("Bad response type");
      i.rows.setData(g(o));
    });
  }
  s.init.push(() => {
    a = s.loader, s.loader = d;
  }), s.inputs.unshift((l, m) => {
    if (m === i.rows && (t = !1, o = [], Array.isArray(l)))
      return o = l, l;
  });
  let c;
  f("compute", (l) => {
    if (!l(e.$params)) {
      c = !1;
      return;
    }
    if (c = !0, t) {
      e.loading = !0;
      return;
    }
    i.rows.setData(g(o)), e.$rows = {};
  });
  function w() {
    !t || !c || Promise.resolve(d()).then(() => (M(e, { $rows: {}, loading: !1, scrollY: 0 }), r())).catch(u);
  }
  f("mount", w), f("update", w);
}
function T() {
  return le;
}
function Fe(e, r, f, u) {
  if (!e)
    return;
  function i(t, o) {
    if (typeof u != "function" || !t)
      return o;
    if (t.type === "identifier")
      return u(t.name, o);
    if (t.type === "member")
      return i(t.object, u(t.property, o));
  }
  function s(t) {
    let o, a;
    if (t.operator && !r[t.operator])
      throw Error("Translation undefined for operator: " + t.operator);
    if (t.variant && !f[t.variant])
      throw Error("Format undefined for variant: " + t.variant);
    let g, d;
    switch (t.type) {
      case "literal":
        return t.value;
      case "identifier":
        return t.name;
      case "member":
        switch (typeof u) {
          case "undefined":
            throw Error("Nested fields not supported");
          case "string":
            return s(t.object) + u + t.property;
          case "function":
            return t.property;
          default:
            throw Error("Type error");
        }
      case "binary":
        return g = s(t.left), d = s(t.right), o = r[t.operator], a = f[t.variant], i(t.left.object, a(g, o, d));
      case "unary":
        return o = r[t.operator], a = f[t.variant], a(o, s(t.argument));
      case "logical":
        return o = r[t.operator], a = f[t.variant], a(o, t.arguments.map(s));
      default:
        throw Error(`Unknown expression type: ${t.type}`);
    }
  }
  return s(q(e));
}
function pe({ props: e, state: r, callbacks: f }, u) {
  let { where: i } = e, s = !1, t = () => !0;
  typeof i > "u" && (i = u), f.precompute.unshift((o) => {
    if (typeof e.where < "u" && (i = e.where), !o(i))
      return;
    let a = q(i);
    a && (t = (g) => ae(a, g)), r.$params = {};
  }), f.transform.unshift((o) => !Array.isArray(o) || !i || s ? o : o.filter(t)), f.getparams.push(() => {
    if (s = !0, i)
      return { where: i };
  });
}
function Me(e) {
  return [T(), (r) => pe(r, e)];
}
function de({ state: e, update: r, api: f, callbacks: u }) {
  let i = [], s = 100, t = 0, o;
  function a(c) {
    return Math.floor(Math.max(0, (t - 1) * Math.min(1, c)) / s);
  }
  function g() {
    Promise.resolve(f.operations.getCount()).then((c) => {
      t = Number(c), f.rows.setTotalCount(t), e.$rows = {}, r();
    });
  }
  function d(c) {
    let w = Object.assign({}, o, c), l = f.operations.getRows;
    return Promise.resolve(w).then(l).then((m) => {
      Array.isArray(m) ? (!t && f.operations.getCount && (t = m.length, g()), f.rows.addBlock(m, c.offset)) : typeof m == "object" && ("count" in m && (t = Number(m.count), f.rows.setTotalCount(t)), f.rows.addBlock(m.items, c.offset));
    });
  }
  u.loader = function(c) {
    return o = c, i = [!0], f.rows.clear(), d({ offset: 0, limit: s });
  }, u.preload = (c = 0, w = 1) => {
    if (!i[0])
      return;
    let l = a(c);
    i[l] && (l += w, l < 0 || l * s >= t || i[l]) || (i[l] = !0, d({ offset: l * s, limit: s }));
  };
}
function me() {
  return de;
}
const { assign: k } = Object;
function he({ props: e, state: r, update: f, api: u, callbacks: i }, s = 100) {
  let t = 0, o = s;
  typeof e.offset < "u" && (t = e.offset), typeof e.limit < "u" && (o = e.limit), k(r, {
    totalCount: 0,
    pageStart: 1,
    pageEnd: s,
    hasNextPage: !0,
    hasPreviousPage: !0,
    sizeList: [10, 20, 50, 100, 200, 500],
    bottomToolbar: "pagination"
  }), u.setPageSize = function(a) {
    t = 0, o = a, f();
  }, u.loadPrevPage = function() {
    t -= o, f();
  }, u.loadNextPage = function() {
    t += o, f();
  }, i.precompute.unshift((a) => {
    typeof e.offset < "u" && (t = e.offset), typeof e.limit < "u" && (o = e.limit);
    let g = a(r.$rows);
    if (!a(t, o, r.$rows))
      return;
    g || (r.$params = {});
    let d = u.rows.count || 0;
    k(r, {
      offset: t,
      limit: o,
      totalCount: d,
      pageStart: t + 1,
      pageEnd: Math.min(d, t + o),
      hasPreviousPage: t > 0,
      hasNextPage: t + o < d
    });
  }), i.init.push(() => i.transform.push((a) => Array.isArray(a) ? a.slice(t, t + o) : a)), i.loader = function(a) {
    let g = u.rows, d = u.operations.getRows;
    a = k({}, a, { offset: t, limit: o });
    function c() {
      !u.operations.getCount || g !== u.rows || Promise.resolve(u.operations.getCount()).then((w) => {
        g.count = Number(w), r.$rows = {}, f();
      });
    }
    return Promise.resolve(a).then(d).then((w) => {
      if (!w)
        g.setData([]);
      else if (Array.isArray(w))
        g.setData(w), c();
      else if (Array.isArray(w.items))
        g.setData(w.items), g.count = w.count || w.items.length;
      else
        throw new Error("Bad response type");
    });
  };
}
function Se(e) {
  return [T(), (r) => he(r, e)];
}
function Be(e, r, f, u) {
  if (!e)
    return;
  let i = e.split(",").map((s) => {
    let [t, o = "asc", ...a] = s.replace(/\s+/g, " ").replace(/^ | $/g, "").split(" ");
    if (a.length)
      throw Error("Cannot parse: " + s);
    let g = t.split(".");
    if (g.length > 1)
      if (typeof u == "string")
        t = g.join(u);
      else if (typeof u == "function")
        t = g[g.length - 1];
      else
        throw Error("Sorting nested fields not supported: " + t);
    let d = r(t, o.toLowerCase());
    if (typeof u == "function")
      for (let c = g.length - 2; c >= 0; c--)
        d = u(g[c], d);
    return d;
  });
  return f ? f(i) : i;
}
function ge({ props: e, state: r, update: f, cls: u, api: i, callbacks: s }, t) {
  let { orderBy: o } = e, a = !1, g = {};
  typeof o > "u" && (o = t);
  function d(l, m) {
    return l > m ? 1 : m > l ? -1 : 0;
  }
  function c() {
    let [l, m] = o.split(" "), y = m === "desc" ? -1 : 1, $ = l.split(".");
    function C(E, b) {
      let n = 0, v = 0;
      for (; E && n < $.length; )
        E = E[$[n++]];
      for (; b && v < $.length; )
        b = b[$[v++]];
      return y * d(E, b);
    }
    return $.length > 1 ? C : function(E, b) {
      return y * d(E[l], b[l]);
    };
  }
  s.precompute.unshift((l) => {
    if (typeof e.orderBy < "u" && (o = e.orderBy), !l(o))
      return;
    let [m, y] = o.split(" ");
    g = { [m]: y }, r.$columns = {}, r.$params = {};
  }), s.column.push(function(l) {
    g[l.field] && (l.direction = g[l.field], l.header[u] = "ax-sort-" + l.direction);
  }), s.transform.push((l) => (!Array.isArray(l) || !o || a || (l = l.slice(), l.sort(c())), l)), s.getparams.push(() => {
    if (a = !0, o)
      return { orderBy: o };
  });
  function w(l) {
    let { field: m, direction: y } = l;
    return m + (y === "asc" ? " desc" : " asc");
  }
  s.click.push(({ target: l }) => {
    let m = i.cellFromElement(l);
    m && m.section === "headers" && (o = w(m.column), f());
  });
}
function Ue(e) {
  return [T(), (r) => ge(r, e)];
}
const { assign: S } = Object;
function we(e, r) {
  let f = 0, u = 0, i, s = {};
  e.preload || (e.preload = () => null);
  function t(n) {
    return n.next ? n.next.index - n.index : f - n.index;
  }
  function o(n) {
    return n.next ? n.next.offset - n.offset : u - n.offset;
  }
  function a(n, v) {
    let h, p = S({}, ...n);
    for (h in p)
      typeof p[h] == "object" ? p[h] = a(n.map((x) => x && x[h])) : h === v && (p[h] = n.map((x) => x && x[h]).filter((x) => x).join(" "));
    return p;
  }
  function g(n, v) {
    let h = (n.records.length * n.offset + v * o(n)) / (u * n.records.length - o(n)), p = n.records[v], x = s, A = n.index + v, j = e.rowID(p, A);
    !n.next && v === n.records.length - 1 && (h = 1);
    let O = { data: p, id: j, index: A, pos: h, calc: x, block: n, at: v };
    return e.rowCalc && (O.calc = e.rowCalc(p)), S(a(e.row.map((L) => L(p, j, A, h, O.calc)), r), O);
  }
  function d(n, v, h, p = []) {
    for (let x = v; x < n.records.length && p.length < h; x++)
      p.push(g(n, x));
    return p.length < h && n.next && n.next.records ? d(n.next, 0, h, p) : p;
  }
  function c(n, v, h, p = []) {
    for (let x = v; x >= 0 && p.length < h; x--)
      p.unshift(g(n, x));
    return p.length < h && n.prev && n.prev.records ? c(n.prev, n.prev.records.length - 1, h, p) : p;
  }
  function w(n, v, h, p, x) {
    let A = n.offset;
    for (x = x || Math.max(h, 50) * o(n) / t(n), p = Math.min(u, p + x); n.next && p >= n.next.offset; )
      n = n.next;
    for (; n.offset > A && (p - x < n.offset || !n.records); )
      n.records && (x -= p - n.offset), p = n.offset, n = n.prev;
    p -= x;
    let j = Math.floor(t(n) * Math.min(1, (p - n.offset) / o(n)));
    return n.offset > A || j > v ? d(n, j, h) : d(n, v, h);
  }
  function l(n, v, h, p, x) {
    let A = n.offset;
    for (x = x || Math.max(h, 50) * o(n) / t(n), p = Math.max(0, p - x); n.prev && p < n.offset; )
      n = n.prev;
    for (; n.offset < A && (p + x > n.next.offset || !n.records); )
      n.records && (x -= n.next.offset - p), n = n.next, p = n.offset;
    p += x;
    let j = Math.floor(t(n) * Math.max(0, (p - n.offset) / o(n)));
    return n.offset < A || j < v ? c(n, j, h) : c(n, v, h);
  }
  function m(n, v = 1e3, h) {
    let p = n ? n.block : i, x = n ? n.at : -1;
    return e.preload(h, 1), !p || !v ? [] : typeof h == "number" ? w(p, x + 1, v, h * u) : d(p, x + 1, v);
  }
  function y(n, v = 1e3, h) {
    let p = n ? n.block : i, x = n ? n.at : -1;
    return e.preload(h, -1), !p || !v ? [] : typeof h == "number" ? l(p, x - 1, v, h * u) : c(p, x - 1, v);
  }
  function $(n, v) {
    let h = i;
    f || (f = n.length, u = f);
    let p = {
      next: null,
      prev: null,
      offset: v || 0,
      index: v || 0,
      records: n
    };
    h || (h = {
      next: null,
      prev: null,
      offset: 0,
      index: 0
    });
    let x = h;
    for (; h.next && h.next.index <= p.index; )
      h = h.next;
    if (h.records)
      throw new Error("overlapping blocks");
    let A = p, j = p;
    h.offset < p.offset ? (A = {
      next: p,
      prev: h.prev,
      offset: h.offset,
      index: h.index
    }, p.prev = A) : p.prev = h.prev, h.offset + o(h) > p.offset + p.records.length ? (j = {
      next: h.next,
      prev: p,
      offset: p.offset + p.records.length,
      index: p.index + p.records.length
    }, p.next = j) : p.next = h.next, h.prev && (h.prev.next = A), h.next && (h.next.prev = j), i = A.prev ? x : A;
  }
  function C(n) {
    f = n, u = f, i && i.records && !i.next && (i.next = {
      next: null,
      prev: i,
      offset: i.records.length,
      index: i.records.length
    });
  }
  function E(n) {
    if (n || (n = []), Array.isArray(n))
      f = n.length, u = f, i = {
        next: null,
        prev: null,
        offset: 0,
        index: 0,
        records: n
      };
    else
      throw new Error("array data expected");
  }
  function b() {
    i = null;
  }
  return { getNext: m, getPrev: y, addBlock: $, clear: b, setData: E, setTotalCount: C };
}
function ye({ cls: e, api: r, callbacks: f, assign: u }) {
  r.rows = we(f, u);
}
function xe() {
  return ye;
}
function qe() {
  return [me(), xe()];
}
export {
  ke as activeCell,
  Te as activeRow,
  Ie as auth,
  ve as cell,
  $e as column,
  Fe as convertFilter,
  Be as convertSort,
  Ee as data,
  Re as edit,
  Me as filter,
  W as format,
  G as http,
  Ce as intl,
  qe as lazy,
  me as loader,
  X as operations,
  Se as pagination,
  be as params,
  Ae as request,
  je as response,
  Ne as rest,
  Pe as row,
  De as select,
  Ue as sort,
  xe as store,
  T as transform,
  Oe as type
};
//# sourceMappingURL=index.js.map
